#include <stdio.h>
#include <stdlib.h>
#include <conio.h>



float	Camera_x,Camera_y,Camera_z;
int		Camera_angX =0,Camera_angY=0,Camera_angZ=0;
int		xm = 400, ym=300;


bool RotateObject(D3Object_ptr Object, int angleX, int angleY, int angleZ);
bool RenderObject(D3Object_ptr Object);
void RotateVertexNormals(D3Object_ptr Object, int angleX, int angleY, int angleZ);
bool LightenObject(D3Object_ptr Object, D3Vertex_ptr SpotLight);
void Local_To_World_Object(D3Object_ptr Object);
void PositionObject(D3Object_ptr Object, int x, int y, int z);
void PositionObject(D3Object_ptr Object, int xtrans, int ytrans, int ztrans);



/////////////////////////////////////////////// Camera Transformations //////////

void PositionCamera(int x, int y, int z)
{	Camera_x = x;
	Camera_y = y;
	Camera_z = z;
}


void TranslateCamera(int xtrans, int ytrans, int ztrans)
{	Camera_x += xtrans;
	Camera_y += ytrans;
	Camera_z += ztrans;
}


void AimCamera(int AngleX, int AngleY, int AngleZ)
{	if (AngleX>359) AngleX = 0;
	else if (AngleX<0) AngleX = 359;

	if (AngleY>359) AngleY = 0;
	else if (AngleY<0) AngleY = 359;

	if (AngleZ>359) AngleZ = 0;
	else if (AngleZ<0) AngleZ = 359;
	
	Camera_angX = AngleX;
	Camera_angY = AngleY;
	Camera_angZ = AngleZ;
}


void RotateCamera(int AngleX, int AngleY, int AngleZ)
{	Camera_angX += AngleX;
	Camera_angY += AngleY;
	Camera_angZ += AngleZ;

	if (Camera_angX>359) Camera_angX = 0;
	else if (Camera_angX<0) Camera_angX = 359;

	if (Camera_angY>359) Camera_angY = 0;
	else if (Camera_angY<0) Camera_angY = 359;

	if (Camera_angZ>359) Camera_angZ = 0;
	else if (Camera_angZ<0) Camera_angZ = 359;
}

/////////////////////////////////////////////// Object Transformations //////////

void PositionObject(D3Object_ptr Object, int x, int y, int z)
{	Object->World_Pos.x = x;
	Object->World_Pos.y = y;
	Object->World_Pos.z = z;
}


void TranslateObject(D3Object_ptr Object, int xtrans, int ytrans, int ztrans)
{	Object->World_Pos.x += xtrans;
	Object->World_Pos.y += ytrans;
	Object->World_Pos.z += ztrans;
}


bool RotateObject(D3Object_ptr Object, int angleX, int angleY, int angleZ)
{	float temp_x,temp_y,temp_z;
	
	if ( (angleX==0)&&(angleY==0)&&(angleZ==0)) return false;

	for (int count=0;count<Object->NumVertices;count++)
	{	temp_x	= c[angleX] * Object->Vertices_local[count].x - s[angleX] * Object->Vertices_local[count].y;
		temp_y	= s[angleX] * Object->Vertices_local[count].x + c[angleX] * Object->Vertices_local[count].y;
		
		Object->Vertices_local[count].x = c[angleY] * temp_x - s[angleY] * Object->Vertices_local[count].z;
		temp_z							= s[angleY] * temp_x + c[angleY] * Object->Vertices_local[count].z;

		Object->Vertices_local[count].y = c[angleZ] * temp_y - s[angleZ] * temp_z;
		Object->Vertices_local[count].z = c[angleZ] * temp_z + s[angleZ] * temp_y;
	}
	return true;
}


void Local_To_World_Object(D3Object_ptr Object)
{	
	for (int count=0;count<Object->NumVertices;count++)
	{	Object->Vertices_world[count].x = Object->Vertices_local[count].x + Object->World_Pos.x;
		Object->Vertices_world[count].y = Object->Vertices_local[count].y + Object->World_Pos.y;
		Object->Vertices_world[count].z = Object->Vertices_local[count].z + Object->World_Pos.z;
	}
}


void World_To_Camera_Object(D3Object_ptr Object)
{	float temp_x,temp_y,temp_z;
	
	for (int count=0;count<Object->NumVertices;count++)
	{	Object->Vertices_world[count].x = Object->Vertices_world[count].x - Camera_x;
		Object->Vertices_world[count].y = Object->Vertices_world[count].y - Camera_y;
		Object->Vertices_world[count].z = Object->Vertices_world[count].z - Camera_z;
	}

	for (count=0;count<Object->NumVertices;count++)
	{	temp_x	= negc[Camera_angX] * Object->Vertices_local[count].x - negs[Camera_angX] * Object->Vertices_world[count].y;
		temp_y	= negs[Camera_angX] * Object->Vertices_local[count].x + negc[Camera_angX] * Object->Vertices_world[count].y;
		
		Object->Vertices_world[count].x = negc[Camera_angY] * temp_x - negs[Camera_angY] * Object->Vertices_world[count].z;
		temp_z							= negs[Camera_angY] * temp_x + negc[Camera_angY] * Object->Vertices_world[count].z;

		Object->Vertices_world[count].y = negc[Camera_angZ] * temp_y - negs[Camera_angZ] * temp_z;
		Object->Vertices_world[count].z = negc[Camera_angZ] * temp_z + negs[Camera_angZ] * temp_y;
	}
	
}


bool RenderObject(D3Object_ptr Object)
{	float scale,DivDist;
	float	dist=800;
	int		dist2=500;	

	if (Object->Clip) return false;

	for (int count=0;count<Object->NumVertices;count++)
	{	
		scale = dist/((float)Object->Vertices_world[count].z + dist2);
		
		Object->Vertices_screen[count].x = xm + Object->Vertices_world[count].x * scale ;
		Object->Vertices_screen[count].y = ym + Object->Vertices_world[count].y * scale ;
		Object->Vertices_screen[count].z = 1.0 / (dist - Object->Vertices_world[count].z);
	}
	for (count=0;count<Object->NumFaces;count++)
	{	if (ClipFace(&(Object->Vertices_screen[Object->Faces[count].a]),
					 &(Object->Vertices_screen[Object->Faces[count].b]),
					 &(Object->Vertices_screen[Object->Faces[count].c])) && Object->Faces[count].Clip)
		{
		grDrawTriangle(	&(Object->Vertices_screen[Object->Faces[count].a]),
						&(Object->Vertices_screen[Object->Faces[count].b]),
						&(Object->Vertices_screen[Object->Faces[count].c]));
		}
	}
	return true;
}


void RotateVertexNormals(D3Object_ptr Object, int angleX, int angleY, int angleZ)
{	float temp_x,temp_y,temp_z;

	angleX = 360 - angleX;
	angleY = 360 - angleY;
	angleZ = 360 - angleZ;

	temp_x	= c[angleX] * Object->Spotlight.x - s[angleX] * Object->Spotlight.y;
	temp_y	= s[angleX] * Object->Spotlight.x + c[angleX] * Object->Spotlight.y;
		
	Object->Spotlight.x = c[angleY] * temp_x - s[angleY] * Object->Spotlight.z;
	temp_z				= s[angleY] * temp_x + c[angleY] * Object->Spotlight.z;

	Object->Spotlight.y = c[angleZ] * temp_y - s[angleZ] * temp_z;
	Object->Spotlight.z = c[angleZ] * temp_z + s[angleZ] * temp_y;
}



bool LightenObject(D3Object_ptr Object)
{	float x,y,z;
	float angle;
	float LightDist = 1.f/866.f; // Dit moet natuurlijk realtime !

	if (Object->Clip) return false;

	for (int count=0;count<Object->NumVertices;count++)
	{	
		x = Object->Vertices_normalStat[count].x;
		y = Object->Vertices_normalStat[count].y;
		z = Object->Vertices_normalStat[count].z;
		
		angle = (LightDist*((x * Object->Spotlight.x) + (y * Object->Spotlight.y) + (z * Object->Spotlight.z) ));
		if (angle<0 )
		{	Object->Vertices_screen[count].r = 0;
			Object->Vertices_screen[count].b = 0;
			Object->Vertices_screen[count].g = 0;
		} else
		{	Object->Vertices_screen[count].r = Object->Vertices_local[count].r * angle;
			Object->Vertices_screen[count].b = Object->Vertices_local[count].b * angle;
			Object->Vertices_screen[count].g = Object->Vertices_local[count].g * angle;
		}
	}
	return true;

}


