FxU32 NextTextureOffset = 0;
FxU32 LastTextureOffset ;//= grTexMaxAddress(GR_TMU0);

typedef struct TextureMap_type
{
  GrTexInfo TexInfo;
  FxU32 VideoMemoryAddressTMU0;
  void *TextureData;

} TextureMap;



bool  LoadTexture(char *FileName, TextureMap *Texture);


bool  LoadTexture(char *FileName,TextureMap *Texture )
{	
	Gu3dfInfo TexInfo;
	GrTexInfo SizeInfo;

	long Startaddress;
	long TextureSize;

	grTexFilterMode(GR_TMU0,GR_TEXTUREFILTER_BILINEAR,
							GR_TEXTUREFILTER_BILINEAR);

    // Setup TMU0 for simple texture mapping
    grTexCombine(GR_TMU0,	GR_COMBINE_FUNCTION_LOCAL,
							GR_COMBINE_FACTOR_NONE,
							GR_COMBINE_FUNCTION_LOCAL,
							GR_COMBINE_FACTOR_NONE,
							FXFALSE,FXFALSE);

	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_WRAP);

	if (gu3dfGetInfo(FileName,&TexInfo)==FXFALSE)
	{	printf("Can't find Texture file\n");
		return false;
	}

	// allocate memory for the mipmap:
	TexInfo.data = (void*)malloc(TexInfo.mem_required);

	// Load the mipmap from disk:
	gu3dfLoad(FileName,&TexInfo);

	Texture->TexInfo.data				= TexInfo.data;
	Texture->TexInfo.format				= TexInfo.header.format;
	Texture->TexInfo.aspectRatioLog2	= TexInfo.header.aspect_ratio;
	Texture->TexInfo.smallLodLog2		= TexInfo.header.small_lod;
	Texture->TexInfo.largeLodLog2		= TexInfo.header.large_lod;
	Texture->VideoMemoryAddressTMU0		= NextTextureOffset;

	SizeInfo.smallLodLog2		= TexInfo.header.small_lod;
	SizeInfo.largeLodLog2		= TexInfo.header.large_lod;
	SizeInfo.aspectRatioLog2	= TexInfo.header.aspect_ratio;
	SizeInfo.format				= TexInfo.header.format;
	SizeInfo.data				= TexInfo.data;

	grTexDownloadMipMap(GR_TMU0,NextTextureOffset,GR_MIPMAPLEVELMASK_BOTH,&Texture->TexInfo);

	NextTextureOffset += grTexTextureMemRequired(GR_MIPMAPLEVELMASK_BOTH, &SizeInfo);
	
	return true;
}
